﻿using JPK_VDEK.Core;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace JPK_VDEK
{
    public static class JpkData
    {
        static private JpkExt aJpk;

        public static JPK getBaseJpk()
        {
            JPK jpk = new JPK();
            jpk.Naglowek = aJpk.Naglowek;
            jpk.Podmiot1 = aJpk.Podmiot1;
            jpk.Deklaracja = aJpk.Deklaracja;
            jpk.SprzedazWiersz = aJpk.SprzedazWiersz;
            jpk.SprzedazCtrl = aJpk.SprzedazCtrl;
            jpk.ZakupWiersz = aJpk.ZakupWiersz;
            jpk.ZakupCtrl = aJpk.ZakupCtrl;
            return jpk;
        }
        public static JpkExt getJpk()
        {
            if(aJpk==null)
            {
                JpkData.initJpk();
            }
            return aJpk;
        }
        public static void initJpk()
        {
            aJpk = new JpkExt();

            aJpk.wczytalemGL = false;

            aJpk.Naglowek = new JPKNaglowek();
            aJpk.Naglowek.KodFormularza = new TNaglowekKodFormularza();
            aJpk.Naglowek.CelZlozenia = new TNaglowekCelZlozenia();
            aJpk.Naglowek.KodFormularzaDekl = new TNaglowekKodFormularzaDekl();
            aJpk.Naglowek.WariantFormularzaDekl = 21;
            aJpk.Naglowek.WariantFormularza = 1;

            aJpk.Podmiot1 = new JPKPodmiot1();

            aJpk.Deklaracja = new JPKDeklaracja();

            aJpk.SprzedazWiersz = new List<JPKSprzedazWiersz>();

            aJpk.SprzedazCtrl = new JPKSprzedazCtrl();

            aJpk.ZakupWiersz = new List<JPKZakupWiersz>();

            aJpk.ZakupCtrl = new JPKZakupCtrl();
            aJpk.ViewSP = new ObservableCollection<JPKSprzedazWiersz>();
            aJpk.ViewZA = new ObservableCollection<JPKZakupWiersz>();

            aJpk.Sumy = new JPKSumyKontrola();

            aJpk.Cel = new TCels();
            aJpk.Urz = new US();
        }
    }

    public class JpkExt : JPK
    {
        public void setCel(int poz)
        {
            this.Naglowek.CelZlozenia.Value = Convert.ToSByte(this.Cel.Cel[poz].Key);
        }
        public void setUrzad(int poz)
        {
            string kod = this.Urz.Lista[poz].Kod;
            if(kod.Equals("0271"))
            {
                this.Naglowek.KodUrzedu = TKodUS.Item0271;
            }
            if (kod.Equals("0225"))
            {
                this.Naglowek.KodUrzedu = TKodUS.Item0271;
            }
        }
        public ObservableCollection<JPKSprzedazWiersz> ViewSP { get; set; }
        public ObservableCollection<JPKZakupWiersz> ViewZA { get; set; }

        public JPKSumyKontrola Sumy { get; set; }
        public string outScalony { get; set; }
        public string  UsNazwa { get; set; }
        public bool P55 { get; set; }
        public bool P56 { get; set; }
        public bool P57 { get; set; }
        public bool P58 { get; set; }
        public bool P59 { get; set; }
        public bool P63 { get; set; }
        public bool P64 { get; set; }
        public bool P65 { get; set; }
        public bool P66 { get; set; }
        public bool P67 { get; set; }
        public TCels Cel { get; set; }
        public US Urz { get; set; }
        public bool wczytalemGL { get; set; }
    }
}
